#ifdef ATL_UCLEANM
#define ATL_sJIK0x72x72TN72x72x0_a1_b0 ATL_sgpMBmm_b0
#else
#define ATL_sJIK0x72x72TN72x72x0_a1_b0 ATL_spMBmm_b0
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x2x72TN1x2x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=2, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=1, nu=2, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const float *stM = A + (((Mb) << 6)+((Mb) << 3));
   const float *stN = B + 144;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*2)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 0, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 2
   const int incBm = -72, incBn = 144;
   const int incAk0 = ((incAk) >> 1), incBk0 = ((incBk) >> 1);
   #define incCm 1
   const int incCn = (((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1;
   register float m0;
   register float rC0_0, rC0_1;
   do /* M-loop */
   {
      ATL_pfl1R(pfA);
      ATL_pfl1R(pfA+ATL_L1LS);
      pfA += incPFA;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = pB0[72];
      m0 = rA0 * rB0;

/*
 *    Peel first 2 iterations for C assignment
 */
      rC0_0 = m0;
      m0 = rA0 * rB1;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rB1 = pB0[73];
      rC0_1 = m0;
      m0 = rA0 * rB0;
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rB1 = pB0[74];
      rC0_1 += m0;
      m0 = rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=0; k < 68; k += 2) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[73];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[74];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rB1 = pB0[73];
      rC0_1 += m0;
      m0 = rA0 * rB0;
      pA0 += (incAk0);
      pB0 += (incBk0);
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rC0_1 += m0;
      pA0 += incAk0;
      pB0 += incBk0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK0x2x72TN5x2x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=2, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=5, nu=2, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6)+((Mb) << 3));
   const float *stN = B + 144;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*2)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 288, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 2
   const int incBm = -72, incBn = 144;
   const int incAk0 = ((incAk) >> 1), incBk0 = ((incBk) >> 1);
   #define incCm 5
   const int incCn = (((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1;
   register float m0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1;
   if (pA0 != stM)
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         ATL_pfl1R(pfA+ATL_L1LS);
         ATL_pfl1R(pfA+3*ATL_L1LS);
         ATL_pfl1R(pfA+4*ATL_L1LS);
         ATL_pfl1R(pfA+5*ATL_L1LS);
         ATL_pfl1R(pfA+6*ATL_L1LS);
         ATL_pfl1R(pfA+7*ATL_L1LS);
         ATL_pfl1R(pfA+8*ATL_L1LS);
         ATL_pfl1R(pfA+9*ATL_L1LS);
         ATL_pfl1R(pfA+10*ATL_L1LS);
         pfA += incPFA;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[72];
         rA2 = pA0[144];
         rA3 = pA0[216];
         m0 = rA0 * rB0;
         rA4 = pA0[288];

/*
 *       Peel first 2 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA1 * rB0;
         rB1 = pB0[72];
         rC1_0 = m0;
         m0 = rA2 * rB0;
         rC2_0 = m0;
         m0 = rA3 * rB0;
         rC3_0 = m0;
         m0 = rA4 * rB0;
         rC4_0 = m0;
         m0 = rA0 * rB1;
         rC0_1 = m0;
         m0 = rA1 * rB1;
         rC1_1 = m0;
         m0 = rA2 * rB1;
         rC2_1 = m0;
         m0 = rA3 * rB1;
         rC3_1 = m0;
         m0 = rA4 * rB1;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[73];
         rA2 = pA0[145];
         rA3 = pA0[217];
         rA4 = pA0[289];
         rC4_1 = m0;
         m0 = rA0 * rB0;
         rB1 = pB0[73];
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rC1_0 += m0;
         m0 = rA2 * rB0;
         rC2_0 += m0;
         m0 = rA3 * rB0;
         rC3_0 += m0;
         m0 = rA4 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA1 * rB1;
         rC1_1 += m0;
         m0 = rA2 * rB1;
         rC2_1 += m0;
         m0 = rA3 * rB1;
         rC3_1 += m0;
         m0 = rA4 * rB1;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[74];
         rA2 = pA0[146];
         rA3 = pA0[218];
         rA4 = pA0[290];
         rC4_1 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[74];
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 68; k += 2) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA4 * rB1;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[73];
            rA2 = pA0[145];
            rA3 = pA0[217];
            rA4 = pA0[289];
            rC4_1 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[73];
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA4 * rB1;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[74];
            rA2 = pA0[146];
            rA3 = pA0[218];
            rA4 = pA0[290];
            rC4_1 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[74];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rC1_0 += m0;
         m0 = rA2 * rB0;
         rC2_0 += m0;
         m0 = rA3 * rB0;
         rC3_0 += m0;
         m0 = rA4 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA1 * rB1;
         rC1_1 += m0;
         m0 = rA2 * rB1;
         rC2_1 += m0;
         m0 = rA3 * rB1;
         rC3_1 += m0;
         m0 = rA4 * rB1;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[73];
         rA2 = pA0[145];
         rA3 = pA0[217];
         rA4 = pA0[289];
         rC4_1 += m0;
         m0 = rA0 * rB0;
         rB1 = pB0[73];
         pA0 += (incAk0);
         pB0 += (incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rC1_0 += m0;
         m0 = rA2 * rB0;
         rC2_0 += m0;
         m0 = rA3 * rB0;
         rC3_0 += m0;
         m0 = rA4 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA1 * rB1;
         rC1_1 += m0;
         m0 = rA2 * rB1;
         rC2_1 += m0;
         m0 = rA3 * rB1;
         rC3_1 += m0;
         m0 = rA4 * rB1;
         rC4_1 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
   }
   if (k=M-Mb)
      ATL_sJIK0x2x72TN1x2x2_a1_b0(k, 2, 72, alpha, ca + (((Mb) << 6)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x70x72TN1x5x2_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=70, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=1, nu=5, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const float *stM = A + (((Mb) << 6)+((Mb) << 3));
   const float *stN = B + 5040;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*5)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 0, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 2
   const int incBm = -72, incBn = 360;
   const int incAk0 = ((incAk) >> 1), incBk0 = ((incBk) >> 1);
   #define incCm 1
   const int incCn = (((ldc) << 2)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4;
   register float m0;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[72];
         rB2 = pB0[144];
         rB3 = pB0[216];
         m0 = rA0 * rB0;
         rB4 = pB0[288];

/*
 *       Peel first 2 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC0_1 = m0;
         m0 = rA0 * rB2;
         rC0_2 = m0;
         m0 = rA0 * rB3;
         rC0_3 = m0;
         m0 = rA0 * rB4;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[73];
         rB2 = pB0[145];
         rB3 = pB0[217];
         rB4 = pB0[289];
         rC0_4 = m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC0_3 += m0;
         m0 = rA0 * rB4;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[74];
         rB2 = pB0[146];
         rB3 = pB0[218];
         rB4 = pB0[290];
         rC0_4 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 68; k += 2) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA0 * rB4;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[73];
            rB2 = pB0[145];
            rB3 = pB0[217];
            rB4 = pB0[289];
            rC0_4 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA0 * rB4;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[74];
            rB2 = pB0[146];
            rB3 = pB0[218];
            rB4 = pB0[290];
            rC0_4 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC0_3 += m0;
         m0 = rA0 * rB4;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[73];
         rB2 = pB0[145];
         rB3 = pB0[217];
         rB4 = pB0[289];
         rC0_4 += m0;
         m0 = rA0 * rB0;
         pA0 += (incAk0);
         pB0 += (incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC0_3 += m0;
         m0 = rA0 * rB4;
         rC0_4 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x72x72TN72x72x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=72, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=5, nu=5, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6)+((Mb) << 3));
   const float *stN = B + 5040;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*5)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 288, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 2
   const int incBm = -72, incBn = 360;
   const int incAk0 = ((incAk) >> 1), incBk0 = ((incBk) >> 1);
   #define incCm 5
   const int incCn = (((ldc) << 2)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1, rB2, rB3, rB4;
   register float m0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
            ATL_pfl1W(pC4);
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[72];
            rA2 = pA0[144];
            rA3 = pA0[216];
            m0 = rA0 * rB0;
            rA4 = pA0[288];

/*
 *          Peel first 2 iterations for C assignment
 */
            rC0_0 = m0;
            m0 = rA1 * rB0;
            rB1 = pB0[72];
            rC1_0 = m0;
            m0 = rA2 * rB0;
            rB2 = pB0[144];
            rC2_0 = m0;
            m0 = rA3 * rB0;
            rB3 = pB0[216];
            rC3_0 = m0;
            m0 = rA4 * rB0;
            rB4 = pB0[288];
            rC4_0 = m0;
            m0 = rA0 * rB1;
            rC0_1 = m0;
            m0 = rA1 * rB1;
            rC1_1 = m0;
            m0 = rA2 * rB1;
            rC2_1 = m0;
            m0 = rA3 * rB1;
            rC3_1 = m0;
            m0 = rA4 * rB1;
            rC4_1 = m0;
            m0 = rA0 * rB2;
            rC0_2 = m0;
            m0 = rA1 * rB2;
            rC1_2 = m0;
            m0 = rA2 * rB2;
            rC2_2 = m0;
            m0 = rA3 * rB2;
            rC3_2 = m0;
            m0 = rA4 * rB2;
            rC4_2 = m0;
            m0 = rA0 * rB3;
            rC0_3 = m0;
            m0 = rA1 * rB3;
            rC1_3 = m0;
            m0 = rA2 * rB3;
            rC2_3 = m0;
            m0 = rA3 * rB3;
            rC3_3 = m0;
            m0 = rA4 * rB3;
            rC4_3 = m0;
            m0 = rA0 * rB4;
            rC0_4 = m0;
            m0 = rA1 * rB4;
            rC1_4 = m0;
            m0 = rA2 * rB4;
            rC2_4 = m0;
            m0 = rA3 * rB4;
            rC3_4 = m0;
            m0 = rA4 * rB4;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[73];
            rA2 = pA0[145];
            rA3 = pA0[217];
            rA4 = pA0[289];
            rC4_4 = m0;
            m0 = rA0 * rB0;
            rB1 = pB0[73];
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rB2 = pB0[145];
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rB3 = pB0[217];
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rB4 = pB0[289];
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA4 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA1 * rB2;
            rC1_2 += m0;
            m0 = rA2 * rB2;
            rC2_2 += m0;
            m0 = rA3 * rB2;
            rC3_2 += m0;
            m0 = rA4 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA1 * rB3;
            rC1_3 += m0;
            m0 = rA2 * rB3;
            rC2_3 += m0;
            m0 = rA3 * rB3;
            rC3_3 += m0;
            m0 = rA4 * rB3;
            rC4_3 += m0;
            m0 = rA0 * rB4;
            rC0_4 += m0;
            m0 = rA1 * rB4;
            rC1_4 += m0;
            m0 = rA2 * rB4;
            rC2_4 += m0;
            m0 = rA3 * rB4;
            rC3_4 += m0;
            m0 = rA4 * rB4;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[74];
            rA2 = pA0[146];
            rA3 = pA0[218];
            rA4 = pA0[290];
            rC4_4 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[74];
            pA0 += incAk;
            pB0 += incBk;
/*
 *          Unpeeled K iterations
 */
            for (k=0; k < 68; k += 2) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rB2 = pB0[144];
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rB3 = pB0[216];
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rB4 = pB0[288];
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA0 * rB1;
               rC0_1 += m0;
               m0 = rA1 * rB1;
               rC1_1 += m0;
               m0 = rA2 * rB1;
               rC2_1 += m0;
               m0 = rA3 * rB1;
               rC3_1 += m0;
               m0 = rA4 * rB1;
               rC4_1 += m0;
               m0 = rA0 * rB2;
               rC0_2 += m0;
               m0 = rA1 * rB2;
               rC1_2 += m0;
               m0 = rA2 * rB2;
               rC2_2 += m0;
               m0 = rA3 * rB2;
               rC3_2 += m0;
               m0 = rA4 * rB2;
               rC4_2 += m0;
               m0 = rA0 * rB3;
               rC0_3 += m0;
               m0 = rA1 * rB3;
               rC1_3 += m0;
               m0 = rA2 * rB3;
               rC2_3 += m0;
               m0 = rA3 * rB3;
               rC3_3 += m0;
               m0 = rA4 * rB3;
               rC4_3 += m0;
               m0 = rA0 * rB4;
               rC0_4 += m0;
               m0 = rA1 * rB4;
               rC1_4 += m0;
               m0 = rA2 * rB4;
               rC2_4 += m0;
               m0 = rA3 * rB4;
               rC3_4 += m0;
               m0 = rA4 * rB4;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[73];
               rA2 = pA0[145];
               rA3 = pA0[217];
               rA4 = pA0[289];
               rC4_4 += m0;
               m0 = rA0 * rB0;
               rB1 = pB0[73];
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rB2 = pB0[145];
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rB3 = pB0[217];
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rB4 = pB0[289];
               rC3_0 += m0;
               m0 = rA4 * rB0;
               rC4_0 += m0;
               m0 = rA0 * rB1;
               rC0_1 += m0;
               m0 = rA1 * rB1;
               rC1_1 += m0;
               m0 = rA2 * rB1;
               rC2_1 += m0;
               m0 = rA3 * rB1;
               rC3_1 += m0;
               m0 = rA4 * rB1;
               rC4_1 += m0;
               m0 = rA0 * rB2;
               rC0_2 += m0;
               m0 = rA1 * rB2;
               rC1_2 += m0;
               m0 = rA2 * rB2;
               rC2_2 += m0;
               m0 = rA3 * rB2;
               rC3_2 += m0;
               m0 = rA4 * rB2;
               rC4_2 += m0;
               m0 = rA0 * rB3;
               rC0_3 += m0;
               m0 = rA1 * rB3;
               rC1_3 += m0;
               m0 = rA2 * rB3;
               rC2_3 += m0;
               m0 = rA3 * rB3;
               rC3_3 += m0;
               m0 = rA4 * rB3;
               rC4_3 += m0;
               m0 = rA0 * rB4;
               rC0_4 += m0;
               m0 = rA1 * rB4;
               rC1_4 += m0;
               m0 = rA2 * rB4;
               rC2_4 += m0;
               m0 = rA3 * rB4;
               rC3_4 += m0;
               m0 = rA4 * rB4;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[74];
               rA2 = pA0[146];
               rA3 = pA0[218];
               rA4 = pA0[290];
               rC4_4 += m0;
               m0 = rA0 * rB0;
               rB1 = pB0[74];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rB2 = pB0[144];
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rB3 = pB0[216];
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rB4 = pB0[288];
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA4 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA1 * rB2;
            rC1_2 += m0;
            m0 = rA2 * rB2;
            rC2_2 += m0;
            m0 = rA3 * rB2;
            rC3_2 += m0;
            m0 = rA4 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA1 * rB3;
            rC1_3 += m0;
            m0 = rA2 * rB3;
            rC2_3 += m0;
            m0 = rA3 * rB3;
            rC3_3 += m0;
            m0 = rA4 * rB3;
            rC4_3 += m0;
            m0 = rA0 * rB4;
            rC0_4 += m0;
            m0 = rA1 * rB4;
            rC1_4 += m0;
            m0 = rA2 * rB4;
            rC2_4 += m0;
            m0 = rA3 * rB4;
            rC3_4 += m0;
            m0 = rA4 * rB4;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[73];
            rA2 = pA0[145];
            rA3 = pA0[217];
            rA4 = pA0[289];
            rC4_4 += m0;
            m0 = rA0 * rB0;
            rB1 = pB0[73];
            pA0 += (incAk0);
            pB0 += (incBk0);
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rB2 = pB0[144];
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rB3 = pB0[216];
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rB4 = pB0[288];
            rC3_0 += m0;
            m0 = rA4 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA4 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA1 * rB2;
            rC1_2 += m0;
            m0 = rA2 * rB2;
            rC2_2 += m0;
            m0 = rA3 * rB2;
            rC3_2 += m0;
            m0 = rA4 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA1 * rB3;
            rC1_3 += m0;
            m0 = rA2 * rB3;
            rC2_3 += m0;
            m0 = rA3 * rB3;
            rC3_3 += m0;
            m0 = rA4 * rB3;
            rC4_3 += m0;
            m0 = rA0 * rB4;
            rC0_4 += m0;
            m0 = rA1 * rB4;
            rC1_4 += m0;
            m0 = rA2 * rB4;
            rC2_4 += m0;
            m0 = rA3 * rB4;
            rC3_4 += m0;
            m0 = rA4 * rB4;
            rC4_4 += m0;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            pC1[4] = rC4_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            pC2[4] = rC4_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC3[2] = rC2_3;
            pC3[3] = rC3_3;
            pC3[4] = rC4_3;
            *pC4 = rC0_4;
            pC4[1] = rC1_4;
            pC4[2] = rC2_4;
            pC4[3] = rC3_4;
            pC4[4] = rC4_4;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   ATL_sJIK0x2x72TN5x2x2_a1_b0(M, 2, 72, alpha, ca, lda, cb + 5040, ldb, beta, cc + (70*(ldc)), ldc);
   if (k=M-Mb)
      ATL_sJIK0x70x72TN1x5x2_a1_b0(k, 70, 72, alpha, ca + (((Mb) << 6)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
